/*	@askpw.c - ask for a password
 */
#include <unistd.h>
#include <termio.h>
#include "gen.h"
#define SIZE 8
#define TRY 1

static char *prompt = "Password: ";
#ifndef TCGETA
#define	TIOC	('T'<<8)
#define	TCGETA	(TIOC|1)
#define	TCSETA	(TIOC|2)
#endif

/* @askpw - ask for a password without echoing
 */
char *askpw(register char *new, char *old)
	{
	if (old)
		strcpy(new, old);
	else
		{
		struct termios term;

		ioctl(0, TCGETA, &term);
		term.c_lflag &= ~ECHO;
		ioctl(0, TCSETA, &term);
		write(STDERR_FILENO, prompt, strlen(prompt));
		memset(new, EOS, SIZE);
		read(STDERR_FILENO, new, SIZE);
		term.c_lflag |= ECHO;
		ioctl(0, TCSETA, &term);
		}
	return new;
	}
