#ifndef __PAT_H
#define __PAT_H
/*	PATTERN MATCHING HEADER
 */

#ifndef __PAT__
#define __PAT__	1

#define P_CCHAR	1	/* literal character */
#define P_ANY		2	/* any character */
#define P_SBOL	3	/* beginning of line */
#define P_SEOL	4	/* end of line */
#define P_CLOSE	5	/* reflexive closure */
#define P_CCL		6	/* begin character class */
#define P_NCCL	7	/* begin negated character class */
#define P_RANGE	8	/* range within character class */
#define P_CCLEND	9	/* end of character class */
#define P_PEND	10	/* pattern end */
#define P_RPAR	19	/* right parenthesis */
#define P_LPAR	20	/* left parenthesis */

/*	the substitution structure
 */
typedef struct _msub
	{
	char *mtext;
	unsigned mlen;
	} MSUB;

#ifdef WHITE

#define C_ANY '?'	
#define C_ANYCLOSE	'*'	
#define C_NCCL	'!'	
#define C_CLOSE	'^'	

#else

#define C_ANY '.'	
#define C_ANYCLOSE	'\0'	
#define C_NCCL	'^'	
#define C_CLOSE	'*'	

#endif

#define C_SBOL	'^'	
#define C_SEOL	'$'	
#define C_CCL	'['	
#define C_RANGE	'-'	
#define C_CCLEND	']'	

#endif

#endif
